Summary: Statically linked binary providing simplified versions of system commands
Name: busybox
Version: 1.2.0
Release: 10.el5.centos
Epoch: 1
License: GPL
Group: System Environment/Shells
Source: http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2
Patch: busybox-1.2.0-static.patch
Patch1: busybox-1.2.0-anaconda.patch
Patch2: busybox-1.2.0-selinux.patch
Patch4: busybox-1.2.0-ppc64.patch
Patch5: busybox-1.2.0-page_size.patch
Patch7: busybox-1.2.0-id_ps.patch
Patch8: busybox-1.2.0-gcc41.patch
Patch9: busybox-1.2.0-tar.patch
Patch10: busybox-1.2.0-dmesg.patch
Patch11: busybox-1.2.0-ash.patch
Patch12: busybox-1.2.0-hwclock.patch
Patch13: busybox-1.2.0-diff.patch
Patch14: busybox-1.2.0-rpm.patch
Patch15: busybox-1.2.0-uname.patch
Patch16: busybox-1.2.0-diff_err.patch
Patch17: busybox-1.2.0-msh1.patch
Patch18: busybox-1.2.0-msh2.patch
Patch19: busybox-1.2.0-grep.patch
Patch20: busybox-1.2.0-msh3.patch
URL: http://www.busybox.net
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: libselinux-devel >= 1.27.7-2
BuildRequires: libsepol-devel

%define debug_package %{nil}

%package anaconda
Group: System Environment/Shells
Summary: Version of busybox configured for use with anaconda

%description 
Busybox is a single binary which includes versions of a large number
of system commands, including a shell.  This package can be very
useful for recovering from certain types of system failures,
particularly those involving broken shared libraries.

%description anaconda
Busybox is a single binary which includes versions of a large number
of system commands, including a shell.  The version contained in this
package is designed for use with the CentOS installation program,
anaconda. The busybox package provides a binary better suited to
normal use.

%prep
%setup -q
#SELINUX Patch
%patch2 -b .selinux -p1
%patch -b .static -p1
%ifarch ppc64
%patch4 -b .ppc64 -p1
%endif
%patch5 -b .ia64 -p1
%patch7 -b .id_ps -p1
%patch8 -b .gcc111 -p1
%patch9 -b .tar -p1
%patch10 -b .dmesg -p1
%patch11 -b .ash -p1
%patch12 -b .rtc -p1
%patch13 -b .q -p1
%patch14 -b .glibc -p1
%patch15 -b .a -p1
%patch16 -b .err -p1
%patch17 -b .msh1 -p1
%patch18 -b .msh2 -p1
%patch19 -b .grep -p1
%patch20 -b .msh3 -p1

%build
make defconfig
make CC="gcc $RPM_OPT_FLAGS"
cp busybox busybox-static
make clean

# revert the patch
find . -name "*.static" | while read n; do
    mv $n $(echo $n | sed 's/\.static$//')
done

patch -b --suffix .anaconda -p1 < %{PATCH1}
#patch -b --suffix .gcc111 -p1 <%{PATCH8}
make DOLFS=y defconfig
make CONFIG_DEBUG=y CC="gcc $RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
install -m 755 busybox-static $RPM_BUILD_ROOT/sbin/busybox
install -m 755 busybox $RPM_BUILD_ROOT/sbin/busybox.anaconda
install -m 644 docs/BusyBox.1 $RPM_BUILD_ROOT/%{_mandir}/man1/busybox.1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/sbin/busybox
%{_mandir}/man1/busybox*

%files anaconda
%defattr(-,root,root)
/sbin/busybox.anaconda

%changelog
* Thu Jul 21 2011 Karanbir Singh <kbsingh@centos.org> - 1:1.2.0-10.el5.centos
- roll in CentOS Branding change to the Spec file

* Tue May 31 2011 Denys Vlasenko <dvlasenk@redhat.com> - 1:1.2.0-10
- Resolves: #708942
  "while loop cannot quit even if the list after while has failed"

* Tue Apr  5 2011 Denys Vlasenko <dvlasenk@redhat.com> - 1:1.2.0-9
- Resolves: #608927
  "busybox grep -Fi" doesn't work as expected
  (-i was ignored)

* Tue Apr  5 2011 Denys Vlasenko <dvlasenk@redhat.com> - 1:1.2.0-8
- Resolves: #678701
  kdump fails with "out of string space" error then panics
  (a shell memory leak problem)

* Thu Jul  2 2009 Ivana Varekova <varekova@redhat.com> - 1:1.2.0-7
- Resolves: #500547
  remove empty debuginfo package


* Tue Jun  9 2009 Ivana Varekova <varekova@redhat.com> - 1:1.2.0-6
- Related: #385661
 'diff -q' command returns wrong status

* Mon Mar 16 2009 Ivana Varekova <varekova@redhat.com> - 1:1.2.0-5
- Resolves: #440623
  there should be %{?dist} instead of %{dist}
- Resolves: #385661
  'diff -q' command returns wrong status
- Resolves: #466896
  fix rpm applet
- Resolves: #480105
  fix uname applet

* Fri Jan  4 2008 Ivana Varekova <varekova@redhat.com> - 1:1.2.0-4
- Resolves: #218851
  add ash shell
- Resolves: #236218
  fix hwclock command on ia64 architecture

* Mon Aug 28 2006 Ivana Varekova <varekova@redhat.com> - 1:1.2.0-3
- fix #200470 - dmesg aborts
  backport dmesg upstream changes

* Mon Aug 28 2006 Ivana Varekova <varekova@redhat.com> - 1:1.2.0-2
- fix #202891 - tar problem

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 1:1.2.0-1.1
- rebuild

* Tue Jul  4 2006 Ivana Varekova <varekova@redhat.com> - 1:1.2.0-1
- update to 1.2.0

* Thu Jun  8 2006 Jeremy Katz <katzj@redhat.com> - 1:1.1.3-2
- fix so that busybox.anaconda has sh

* Wed May 31 2006 Ivana Varekova <varekova@redhat.com> - 1:1.1.3-1
- update to 1.1.3

* Mon May 29 2006 Ivana Varekova <varekova@redhat.com> - 1:1.1.2-3
- fix Makefile typo (#193354)

* Fri May  5 2006 Ivana Varekova <varekova@redhat.com> - 1:1.1.2-1
- update to 1.1.2

* Thu May  4 2006 Ivana Varekova <varekova@redhat.com> - 1:1.1.1-2
- add -Z option to id command, rename ps command -Z option (#190534)

* Wed May 03 2006 Ivana Varekova <varekova@redhat.com> - 1:1.1.1-1
- update to 1.1.1
- fix CVE-2006-1058 - BusyBox passwd command 
  fails to generate password with salt (#187386)
- add -minimal-toc option
- add RPM_OPT_FLAGS
- remove asm/page.h used sysconf command to get PAGE_SIZE
- add overfl patch to aviod Buffer warning

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 1:1.01-2.2.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 1:1.01-2.2
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Oct 13 2005 Daniel Walsh <dwalsh@redhat.com> -  1.01-2
- Add sepol for linking load_policy

* Thu Sep  1 2005 Ivana Varekova <varekova@redhat.com> - 1.01-1
- update to 1.01
 
* Tue May 11 2005 Ivana Varekova <varekova@redhat.com> - 1.00-5
- add debug files to debug_package

* Mon Mar  7 2005 Ivana Varekova <varekova@redhat.com> - 1.00-4
- rebuilt

* Wed Jan 26 2005 Ivana Varekova <varekova@redhat.com> - 1.00-3
- update to 1.00 - fix bug #145681
- rebuild

* Thu Jan 13 2005 Jeremy Katz <katzj@redhat.com> - 1.00.rc1-6
- enable ash as the shell in busybox-anaconda

* Sat Oct  2 2004 Bill Nottingham <notting@redhat.com> - 1.00.rc1-5
- fix segfault in SELinux patch (#134404, #134406)

* Fri Sep 17 2004 Phil Knirsch <pknirsch@redhat.com> - 1.00.rc1-4
- Fixed double free in freecon() call (#132809)

* Fri Sep 10 2004 Daniel Walsh <dwalsh@redhat.com> - 1.00.rc1-3
- Add CONFIG_STATIC=y for static builds

* Wed Aug 25 2004 Jeremy Katz <katzj@redhat.com> - 1.00.rc1-2
- rebuild

* Fri Jun 25 2004 Dan Walsh <dwalsh@redhat.com> 1.00-pre10.1
- Add BuildRequires libselinux-devel
- Update to latest from upstream

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue May 11 2004 Karsten Hopp <karsten@redhat.de> 1.00.pre8-4 
- add mknod to busybox-anaconda

* Wed Apr 21 2004 Karsten Hopp <karsten@redhat.de> 1.00.pre8-3 
- fix LS_COLOR in anaconda patch

* Tue Mar 23 2004 Jeremy Katz <katzj@redhat.com> 1.00.pre8-2
- add awk to busybox-anaconda

* Sat Mar 20 2004 Dan Walsh <dwalsh@redhat.com> 1.00-pre8.1
- Update with latest patch. 
- Turn off LS_COLOR in static patch

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Jan 27 2004 Dan Walsh <dwalsh@redhat.com> 1.00-pre5.2
- Fix is_selinux_enabled calls

* Mon Dec 29 2003 Dan Walsh <dwalsh@redhat.com> 1.00-pre5.1
-Latest update

* Wed Nov 26 2003 Dan Walsh <dwalsh@redhat.com> 1.00-pre3.2
- Add insmod

* Mon Sep 15 2003 Dan Walsh <dwalsh@redhat.com> 1.00-pre3.1
- Upgrade to pre3

* Thu Sep 11 2003 Dan Walsh <dwalsh@redhat.com> 1.00.2
- Upgrade selinux support

* Wed Jul 23 2003 Dan Walsh <dwalsh@redhat.com> 1.00.1
- Upgrade to 1.00 package

* Wed Jul 16 2003 Elliot Lee <sopwith@redhat.com> 0.60.5-10
- Rebuild

* Mon Jul 14 2003 Jeremy Katz <katzj@redhat.com> 0.60.5-9
- rebuild

* Mon Jul 14 2003 Jeremy Katz <katzj@redhat.com> 0.60.5-8
- add dmesg to busybox-anaconda

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Mon Jan 13 2003 Jeremy Katz <katzj@redhat.com> 0.60.5-5
- lost nolock for anaconda mount when rediffing, it returns (#81764)

* Mon Jan 6 2003 Dan Walsh <dwalsh@redhat.com> 0.60.5-4
- Upstream developers wanted to eliminate the use of floats

* Thu Jan 3 2003 Dan Walsh <dwalsh@redhat.com> 0.60.5-3
- Fix free to work on large memory machines.

* Sat Dec 28 2002 Jeremy Katz <katzj@redhat.com> 0.60.5-2
- update Config.h for anaconda build to include more useful utils

* Thu Dec 19 2002 Dan Walsh <dwalsh@redhat.com> 0.60.5-1
- update latest release

* Thu Dec 19 2002 Dan Walsh <dwalsh@redhat.com> 0.60.2-8
- incorporate hammer changes

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon May 06 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- fix compilation on mainframe

* Tue Apr  2 2002 Jeremy Katz <katzj@redhat.com>
- fix static busybox (#60701)

* Thu Feb 28 2002 Jeremy Katz <katzj@redhat.com>
- don't include mknod in busybox.anaconda so we get collage mknod

* Fri Feb 22 2002 Jeremy Katz <katzj@redhat.com>
- rebuild in new environment

* Wed Jan 30 2002 Jeremy Katz <katzj@redhat.com>
- update to 0.60.2
- include more pieces for the anaconda version so that collage can go away
- make the mount in busybox.anaconda default to -onolock

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
`- automated rebuild

* Mon Jul  9 2001 Tim Powers <timp@redhat.com>
- don't obsolete sash
- fix URL and spelling in desc. to satisfy rpmlint

* Thu Jul 05 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- add missing defattr for anaconda subpackage

* Thu Jun 28 2001 Erik Troan <ewt@redhat.com>
- initial build for Red Hat
